import React from "react";
import { IThreepid } from "matrix-js-sdk/src/@types/threepids";
import { ServicePolicyPair } from "../../../../../Terms";
import MatrixClientContext from "../../../../../contexts/MatrixClientContext";
interface IProps {
    closeSettingsFn: () => void;
}
interface IState {
    language: string;
    spellCheckEnabled?: boolean;
    spellCheckLanguages: string[];
    haveIdServer: boolean;
    serverSupportsSeparateAddAndBind?: boolean;
    idServerHasUnsignedTerms: boolean;
    requiredPolicyInfo: {
        hasTerms: false;
        policiesAndServices: null;
        agreedUrls: null;
        resolve: null;
    } | {
        hasTerms: boolean;
        policiesAndServices: ServicePolicyPair[];
        agreedUrls: string[];
        resolve: (values: string[]) => void;
    };
    emails: IThreepid[];
    msisdns: IThreepid[];
    loading3pids: boolean;
    canChangePassword: boolean;
    idServerName?: string;
    externalAccountManagementUrl?: string;
}
export default class GeneralUserSettingsTab extends React.Component<IProps, IState> {
    static contextType: React.Context<import("matrix-js-sdk/src/client").MatrixClient>;
    context: React.ContextType<typeof MatrixClientContext>;
    private readonly dispatcherRef;
    constructor(props: IProps);
    componentDidMount(): Promise<void>;
    componentWillUnmount(): void;
    private onAction;
    private onEmailsChange;
    private onMsisdnsChange;
    private getCapabilities;
    private getThreepidState;
    private checkTerms;
    private onLanguageChange;
    private onSpellCheckLanguagesChange;
    private onSpellCheckEnabledChange;
    private onPasswordChangeError;
    private onPasswordChanged;
    private onDeactivateClicked;
    private renderAccountSection;
    private renderLanguageSection;
    private renderSpellCheckSection;
    private renderDiscoverySection;
    private renderManagementSection;
    private renderIntegrationManagerSection;
    render(): React.ReactNode;
}
export {};
